#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

int insert(vector<int> &s, int a) {
	int mark = 0;
	rep(i, 1, s.size()) {
		if((s[i-1] | s[i] | a) == 7) {
			mark = i;
			break;
		}
	}
	if(mark) {
		s.push_back(0);
		for(int i = s.size() - 1; i > mark; i--) {
			s[i] = s[i-1];
		}
		s[mark] = a;
	}
	return mark;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T; cin >> T;
	while(T--) {
		int n; cin >> n;
		string s; cin >> s;

		vector<int> arr(n);
		int most = 0, x = 0, y = 0;
		int a = 1, b = 2, c = 4;
		rep(i, 0, n) {
			if(s[i] == 'L') {
				arr[i] = 1;
				most++;
			}
			if(s[i] == 'I') {
				arr[i] = 2;
				x++;
			}
			if(s[i] == 'T') {
				arr[i] = 4;
				y++;
			}
		}
		
		if(most < x) {
			swap(most, x);
			swap(a, b);
		}
		if(most < y) {
			swap(most, y);
			swap(a, c);
		}

		vector<int> ops;
		while(ops.size() < 2 * n) {
			if(x < most) {
				int op = insert(arr, b);
				if(op) {
					ops.push_back(op);
					x++;
					continue;
				}
			}
			if(y < most) {
				int op = insert(arr, c);
				if(op) {
					ops.push_back(op);
					y++;
					continue;
				}
			}
			if(most == x && x == y) break;
			int op = insert(arr, a);
			if(op) {
				ops.push_back(op);
				most++;
				continue;
			}
			break;
		}

		if(most == x && x == y) {
			cout << ops.size() << '\n';
			for(int op : ops) {
				cout << op << '\n';
			}
		} else {
			cout << -1 << '\n';
		}
	}
}

